;;;; xNgtnbV - IuWFNgɈӓIȔԍ蓖ĂB
;;;; LastChange: Thu Apr 12 23:36:30 2007

;;; -> (setq idtab (make-idtab))
;;; #<idtab nil>
;;; -> (idtab-obj-to-id idtab "foo")
;;; 0
;;; -> (idtab-obj-to-id idtab '(bar))
;;; 1
;;; -> (idtab-obj-to-id idtab "foo")
;;; 0
;;; -> (idtab-obj-to-id idtab '(bar))
;;; 1
;;; -> (idtab-obj-to-id idtab '(b a z))
;;; 2
;;; -> (idtab-length idtab)
;;; 3
;;; -> (idtab-to-list idtab)
;;; ("foo" (bar) (b a z))
;;; -> (aref (list-to-vector (idtab-to-list idtab)) 2)
;;; (b a z)

(require 'que)

(defun make-idtab ()
  ;;  defstruct 
  "IuWFNgiequal ȁjɈӓIȔԍ蓖Ăe[uB
Example:
 -> (setq idtab (make-idtab))
 #<idtab nil>
 -> (idtab-obj-to-id idtab \"foo\")
 0
 -> (idtab-obj-to-id idtab '(bar))
 1
 -> (idtab-obj-to-id idtab \"foo\")
 0
 -> (idtab-obj-to-id idtab '(bar))
 1
 -> (idtab-obj-to-id idtab '(b a z))
 2
 -> (idtab-length idtab)
 3
 -> (idtab-to-list idtab)
 (\"foo\" (bar) (b a z))"
  (vector
   ;; type tag
   'idtab
   ;; number of entries
   0
   ;; objs
   (make-que)
   ;; object -> id
   (make-hash-table :test 'equal)))

(defun idtabp (x)
  ;; (idtabp (make-idtab)) => t
  ;; (idtabp nil) => nil
  (and (vectorp x)
       (= 4 (length x))
       (eq (aref x 0) 'idtab)))

(when (featurep 'elim)
  (elim-add-printer
   'idtabp
   #'(lambda (x) (format "#<idtab %S>" (idtab-to-list x)))))

(defun idtab-length (idtab)
  (or (idtabp idtab)
      (error "Not a idtab: %S" idtab))
  (aref idtab 1))

(defun idtab-to-list (idtab)
  (or (idtabp idtab)
      (error "Not a idtab: %S" idtab))
  (que-to-list (aref idtab 2)))


(defun idtab-obj-to-id (idtab obj)
  (or (idtabp idtab)
      (error "Not a idtab: %S" idtab))
  (let* ((hash (aref idtab 3))
	 (id (gethash obj hash)))
    (unless id
      (setq id (aref idtab 1))
      (puthash obj id hash)
      (aset idtab 1 (1+ id))
      (append-que (aref idtab 2) obj))
    id))

;;;
(provide 'idtab)
