;;;
;;; sck-yayacc output
;;;
(defun sck-yayacc-executor ()
(let (
(sck*yayacc-cc-productions '((START E " EOF") (E E "+-" E) (E " ERROR" "+-" E) (E E "+-" " ERROR") (E E "*/" E) (E " ERROR" "*/" E) (E E "*/" " ERROR") (E "(" E ")") (E "(" " ERROR" ")") (E "+-" E) (E "number")))
(sck*yayacc-cc-lr-table '((0 ((0 0) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) ((" ERROR" 5) ("(" 4) ("+-" 3) ("number" 2) (E 1))) (1 ((0 1) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7) (" EOF" 6))) (2 ((10 (" EOF" ")" "*/" "+-"))) nil) (3 ((9 1) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) ((" ERROR" 5) ("(" 4) ("+-" 3) ("number" 2) (E 17))) (4 ((8 1) (7 1) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) (("(" 4) ("+-" 3) ("number" 2) (E 19) (" ERROR" 18))) (5 ((5 1) (2 1)) (("+-" 12) ("*/" 11))) (6 ((0 nil)) nil) (7 ((6 2) (4 2) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) (("(" 4) ("+-" 3) ("number" 2) (E 10) (" ERROR" 9))) (8 ((3 2) (1 2) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) (("(" 4) ("+-" 3) ("number" 2) (E 16) (" ERROR" 15))) (9 ((6 (" EOF" ")" "*/" "+-")) (5 1) (2 1)) (("+-" 12) ("*/" 11))) (10 ((4 (" EOF" ")" "*/" "+-")) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7))) (11 ((5 2) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) ((" ERROR" 5) ("(" 4) ("+-" 3) ("number" 2) (E 13))) (12 ((2 2) (10 0) (9 0) (8 0) (7 0) (6 0) (5 0) (4 0) (3 0) (2 0) (1 0)) ((" ERROR" 5) ("(" 4) ("+-" 3) ("number" 2) (E 14))) (13 ((5 (" EOF" ")" "*/" "+-")) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7))) (14 ((2 (" EOF" ")" "*/" "+-")) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7))) (15 ((3 (" EOF" ")" "*/" "+-")) (5 1) (2 1)) (("+-" 12) ("*/" 11))) (16 ((1 (" EOF" ")" "*/" "+-")) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7))) (17 ((9 (" EOF" ")" "*/" "+-")) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7))) (18 ((8 2) (5 1) (2 1)) (("+-" 12) ("*/" 11) (")" 20))) (19 ((7 2) (6 1) (4 1) (3 1) (1 1)) (("+-" 8) ("*/" 7) (")" 21))) (20 ((8 (" EOF" ")" "*/" "+-"))) nil) (21 ((7 (" EOF" ")" "*/" "+-"))) nil)))
(sck*yayacc-cc-precs '(nil "+-" "+-" "+-" "*/" "*/" "*/" nil nil " NEG" nil))
(sck*yayacc-cc-actions '($0 (list (intern $1) $0 $2) (list (intern $1) $0 $2) (list (intern $1) $0 $2) (list (intern $1) $0 $2) (list (intern $1) $0 $2) (list (intern $1) $0 $2) $1 $1 (list (intern $0) 0 $1) $0))
(sck*yayacc-cc-associativity '((left ("+-")) (left ("*/")) (left (" NEG"))))
)
(sck-yayacc-cc-executor)
))
;;; -*-elisp-*-
;;; $Id: sck-yayacc-yacc-executor.el,v 1.2 2006/12/25 14:07:40 heavy Exp $
;;; sp{
;;;
(defun sck-yayacc-cc-length (production-no)
  ;; ProductionNo -> Length
  (length (cdr (nth production-no sck*yayacc-cc-productions))))

(defun sck-yayacc-cc-lefthandside (production-no)
  ;; ProductionNo -> NonTerminal
  (car (nth production-no sck*yayacc-cc-productions)))

(defun sck-yayacc-cc-action (production-no values lenvalues)
  ;; (ProductionNo values #ofvalues)
  (let ((action (nth production-no sck*yayacc-cc-actions))
	vars)
    (dotimes (x lenvalues)
      (push (intern (format "$%d" x)) vars))
    (progv (nreverse vars) values
      (eval action))))

(defun sck-yayacc-cc-prec (production-no)
  ;; ProductionNo -> prec
  (nth production-no sck*yayacc-cc-precs))

(defun sck-yayacc-cc-associativity-member (terminal)
  ;; return : (Depth (<Associativity> (<Terminal>..)))
  (let ((depth 0) assoc)
    (block 'assoc
      (dolist (x sck*yayacc-cc-associativity)
	(when (member terminal (cadr x))
	  (setq assoc x)
	  (return-from 'assoc))
	(incf depth)))
    (if assoc 
	(list depth assoc))))

;;
;; 
;;
(defun sck-yayacc-cc-executor ()
  (let (token
	sck*yayacc-cc-state-stack
	sck*yayacc-cc-attribute-stack
	sck*yayacc-cc-token-stack
	syn-attribute
	(loopflag t))
    ;; init stack
    (push 0 sck*yayacc-cc-state-stack)
    (push 0 sck*yayacc-cc-token-stack)
    (push 0 sck*yayacc-cc-attribute-stack)
    (setq token (sck-lex-get-token))
    (while loopflag

      '(print (format 
	      "In Loop: state-stack (%s) attribute-stack (%s) syn-attribute (%s)"
	      sck*yayacc-cc-state-stack
	      sck*yayacc-cc-attribute-stack
	      syn-attribute))


      (let ((statemoves 
	     (sck-yayacc-cc-table (car sck*yayacc-cc-state-stack)
				  (sck-lex-token-id token))))

	'(print (format "statemoves (%S)\n" statemoves))
	
	(cond
	 ((eq (car statemoves) 'shift)
	  (push (cadr statemoves) sck*yayacc-cc-state-stack)
	  (push (sck-lex-token-id token) sck*yayacc-cc-token-stack)
	  (push (sck-lex-token-attr token) sck*yayacc-cc-attribute-stack)
	  
	  (setq token (sck-lex-get-token)))
	 ((eq (car statemoves) 'reduce)
	  (let* ((len (sck-yayacc-cc-length (cadr statemoves)))
		 action-values)
	    (dotimes (x len)
	      (pop sck*yayacc-cc-state-stack)
	      (pop sck*yayacc-cc-token-stack)
	      (push (pop sck*yayacc-cc-attribute-stack) action-values)
	      )
	    ;; action
	    (setq syn-attribute
		  (sck-yayacc-cc-action (cadr statemoves)
					action-values
					len))
	    ;; statemove
	    (let* ((lefthandside 
		    (sck-yayacc-cc-lefthandside (cadr statemoves)))
		   (sm (sck-yayacc-cc-table 
			(car sck*yayacc-cc-state-stack)
			lefthandside)))
	      (when (eq (car sm) 'shift)
		(push (cadr sm) sck*yayacc-cc-state-stack)
		(push lefthandside sck*yayacc-cc-token-stack)
		(push syn-attribute sck*yayacc-cc-attribute-stack)))
	    ))
	 ((eq (car statemoves) 'error)
	  (setq token (sck-yayacc-cc-error-recovery
		       (list (sck-lex-token-line token) token))))
	 ((eq (car statemoves) 'halt)
	  (setq loopflag nil)))))
    ;;
    syn-attribute))

(defun sck-yayacc-cc-error-recovery (errordata)
  ;; return : token

  '(print "sck-yayacc-cc-error-recovery in")

  (let (statemoves token)
    (setq statemoves
	  (sck-yayacc-cc-table (car sck*yayacc-cc-state-stack) " ERROR"))
    ;; ERROR ŃVtgo܂ŃX^bN߂ăVtg
    ;; X^[gXe[g܂ŗ甲
    (while (and (eq (car statemoves) 'error)
		(not (= (car sck*yayacc-cc-state-stack) 0)))
      (let* ((statedata (assoc 
			 (car sck*yayacc-cc-state-stack)
			 sck*yayacc-cc-lr-table))
	     (productions (cadr statedata))
	     (len (if (listp (cadar productions))
		      (sck-yayacc-cc-length (caar productions))
		    (cadar productions))))

	'(print (format "state-stack %S len %d" 
			sck*yayacc-cc-state-stack
			len))

	(dotimes (x len)
	  (pop sck*yayacc-cc-state-stack)
	  (pop sck*yayacc-cc-token-stack)
	  (pop sck*yayacc-cc-attribute-stack))
	(setq statemoves
	      (sck-yayacc-cc-table (car sck*yayacc-cc-state-stack) " ERROR"))))
    ;; X^[gXe[głȂ ERROR ŃVtg
    (when (not (= (car sck*yayacc-cc-state-stack) 0))
      (push (cadr statemoves) sck*yayacc-cc-state-stack)
      (push " ERROR" sck*yayacc-cc-token-stack)
      (push errordata sck*yayacc-cc-attribute-stack))

    ;; ̃g[NŐi߂܂Ńg[Nǂݎ̂Ă
    (setq token (sck-lex-get-token))
    (setq statemoves
	  (sck-yayacc-cc-table (car sck*yayacc-cc-state-stack) (car token)))

    '(print (format "state-stack:%S" sck*yayacc-cc-state-stack))

    (while (eq (car statemoves) 'error)

      '(print (format "token:%S statemoves:%S" token statemoves))

      (setq token (sck-lex-get-token))
      (setq statemoves
	    (sck-yayacc-cc-table (car sck*yayacc-cc-state-stack)
				 (sck-lex-token-id token))))
    token))


(defun sck-yayacc-cc-table (state vocabulary)
  ;; (stete vocabulary) -> (state-moveID stateNo|productionNo)

  '(print (format "in sck-yayacc-cc-table (%s %S)\n" state vocabulary))

  (let* ((statedata (assoc state sck*yayacc-cc-lr-table))
	 (shift (assoc vocabulary (caddr statedata)))
	 reduce)
    ;; reduce/reduce conflicts ̏ꍇ͐̕I 
    (block 'reduce
      (dolist (x (cadr statedata))
	(when (listp (cadr x))
	  (setq reduce x)
	  (return-from 'reduce))))
    ;; shift/reduce conflicts ̏ꍇ assoc 
    (when (and shift 
	       reduce
	       ;; reduce 邩H
	       (or (member vocabulary (cadr reduce))
		   ;; Null ̏ꍇ͑S
		   (null (cadr reduce))))
      ;; shift/reduce conflict
      (let ((assoc (sck-yayacc-cc-associativity-member vocabulary))
	    (stack-term (and (sck-yayacc-cc-prec (car reduce))
			     (sck-yayacc-cc-associativity-member
			      (sck-yayacc-cc-prec (car reduce))))))

	'(print (format "assoc:%S stack-term:%S"
			assoc stack-term))
	    
	(if (and assoc stack-term)
	    (cond
	     ;; Ȃ猋Č߂
	     ((= (car assoc) (car stack-term))
	      (cond
	       ((eq (caadr assoc) 'left)
		(setq shift nil))
	       ((eq (caadr assoc) 'right)
		(setq reduce nil))
	       (t
		;; ǂł΂Ƃ肠 shift
		(setq reduce nil))))
	     ;; D揇ʂقI
	     ((> (car assoc) (car stack-term))
	      (setq reduce nil))
	     (t
	      (setq shift nil)))
	  ;; assoc ŉłȂꍇ shift
	  (setq reduce nil)
	  (message "state%d shift/reduce conflict. ->shift" state))))
    
    '(print (format "shift:%S reduce:%S" shift reduce))
    
    (cond
     (shift
      (list 'shift (cadr shift)))
     (reduce
      (if (or (member vocabulary (cadr reduce))
	      ;; Null ̏ꍇ͑S
	      (null (cadr reduce)))
	  (list 'reduce (car reduce))
	;; LookaheadSet ɖꍇ...
	(list 'error)))
     ;; X^[gXe[gŏI[̏ꍇ
     ((and (= state 0)
	   (equal vocabulary " EOF"))
      (list 'halt))
     (t
      (list 'error)))))
