;;;; $B2r@O$G;HMQ$9$k5-9f$N=89g(B
;;;; LastChange: Sat Dec 30 12:32:54 2006


;;; decl

(defconst sck=cpps-scsys '(typedef auto static extern register))
(defconst sck=cpps-typequalsys '(const volatile))
(defconst sck=cpps-atomictypesys
  '(char short int long signed unsigned float double void))
(defconst sck=cpps-specbegsys
  (append sck=cpps-scsys sck=cpps-atomictypesys sck=cpps-typequalsys
	  '(typename struct union enum)))
(defconst sck=cpps-declbegsys
  (append sck=cpps-typequalsys '(ast ident typename lpa lbk)))
(defconst sck=cpps-gdeclbegsys
  (append sck=cpps-specbegsys sck=cpps-declbegsys '(sem)))


;;; expr

(defconst sck=cpps-primopsys '(lpa lbk hypgre dot plspls hyphyp))
(defconst sck=cpps-setopsys
  '(equ astequ slaequ perequ plsequ hypequ
	ampequ hatequ pipequ leslesequ gregreequ))
(defconst sck=cpps-muldivopsys '(ast sla per))
(defconst sck=cpps-addsubopsys '(pls hyp))
(defconst sck=cpps-shiftopsys '(gregre lesles))
(defconst sck=cpps-compopsys '(les gre lesequ greequ))
(defconst sck=cpps-equalopsys '(equequ excequ))
(defconst sck=cpps-bandopsys '(amp))
(defconst sck=cpps-bxoropsys '(hat))
(defconst sck=cpps-boropsys '(pip))
(defconst sck=cpps-landopsys '(ampamp))
(defconst sck=cpps-loropsys '(pippip))
(defconst sck=cpps-unaopsys '(exc til plspls hyphyp hyp ast amp sizeof))
(defconst sck=cpps-exprleafsys '(ident iconst fconst cconst sconst))
(defconst sck=cpps-exprbegsys
  (append sck=cpps-unaopsys sck=cpps-exprleafsys '(lpa)))


;;; stmt

(defconst sck=cpps-stmtbegsys
  (append sck=cpps-specbegsys
	  sck=cpps-exprbegsys
	  '(sem if while do for switch case
		default break continue return goto lbr)))
(defconst sck=cpps-stmtsuperfsys '(rbr))

;;;
(provide 'sck-cpps-sys)
