/* cps $B$N%G%bMQ%W%m%0%i%`(B LastChange: Sat Mar 24 12:16:35 2007 */

struct data {
  int id;
  char *name;
  int flags[10];
};

struct data datav[] = {{0,"foo",{1,2,3}},  {1,"bar",{4}},  {2}, 0};

struct node {
  struct node *next;
  int key;
  struct data data;
};

typedef struct node Node;


int flagok(int flags[10])
{
  int flag;
  int i;

  for (i = 0, flag = 0; i < 10; i++)
    flag |= flags[i];

  return flag == 0xffffffff;
}

Node *search(Node *root, int key, int (*flagok)(int [10]))
{
  Node *p;

  for (p = root; p; p = p->next)
    if (key == p->key && flagok(p->data.flags))
      return p;

  return (Node*)0;
}
