;;; ex1-ans.el

(defun my-length (x)
  (if (null x)
      0
    (1+ (my-length (cdr x)))))

(defun my-append (x y) 
  (if (null x)
      y
    (cons (car x)
	  (my-append (cdr x) y))))

(defun my-reverse (x)
  (if (null x)
      nil
    (my-append (my-reverse (cdr x)) (list (car x)))))

(defun my-total (ns)
  (if (null ns)
      0
    (+ (car ns) (my-total (cdr ns)))))

(defun my-append* (x)
  (if (null x)
      nil
    (my-append (car x) (my-append* (cdr x)))))

(defun my-member (x y)
  (cond
   ((null y) nil)
   ((equal x (car y)) y) ; y  nil łȂi^j
   (t (my-member x (cdr y)))))

(defun my-assoc (x alist)
  (cond
   ((null alist) nil)
   ((equal x (caar alist)) (car alist))
   (t (my-assoc x (cdr alist)))))

(defun my-elt (x n)
  (if (<= n 0)
      (car x)
    (my-elt (cdr x) (- n 1))))

(defun my-head (x n)
  (if (<= n 0)
      nil
    (cons (car x) (my-head (cdr x) (- n 1)))))

(defun my-zip (x y)
  (cond
   ((null x) nil)
   ((null y) nil)
   (t (cons (list (car x) (car y))
	    (my-zip (cdr x) (cdr y))))))

(defun my-last-elm (x)
  (cond
   ;; 󃊃XgȂ nil
   ((null x) nil)
   ;; vfЂƂȂ炻
   ((null (cdr x)) (car x))
   ;; QȏȂ cdr  last
   (t (my-last-elm (cdr x)))))

(defun my-uniq (x)
  (cond
   ;; 󃊃Xg uniq ͋󃊃Xg
   ((null x) nil)
   ;; x  car  cdr ɓĂ
   ((my-member (car x) (cdr x))
    ;; Ă my-uniq
    (my-uniq (cdr x)))
   ;; x  car  cdr ɓĂȂ
   (t ;; Xg my-uniq ɂ cons
    (cons (car x) (my-uniq (cdr x))))))

(defun my-subsetp (x y)
  (cond
   ;; W͔Cӂ̏W̕W
   ((null x) t)
   ;; x  car  y ɓĂ]݂ŁA
   ((my-member (car x) y)
    ;; x  cdr ɂĂɃ`FbN
    (my-subsetp (cdr x) y))
   ;; x  car  y ɓĂȂΒ nil iUj
   (t nil)))

(defun my-intersection (x y)
  (cond
   ;; x Ȃ
   ((null x) nil)
   ;; x  car  y ɓĂ炻̗vf͋ʏẄvfȂ̂ŁA
   ((my-member (car x) y)
    ;;  x  y Ƃ̋ʏWɂ cons
    (cons (car x) (my-intersection (cdr x) y)))
   ;; x  car  y ɓĂȂ΂̗vf͋ʏW̗vfł͂Ȃ̂ŁA
   (t ;;  x  y ̋ʏW
    (my-intersection (cdr x) y))))
