;;;; This file is automatically created from ~/sck/tmd/sck-tmd-x86.tmd.

(eval-when-compile (setq max-specpdl-size 2000))


(defconst sck=tmd-def-form-list
  '((def *real-reg-symtab*
	 (symtab
	  ("%eax" reg i32 4 nil)
	  ("%ecx" reg i32 4 nil)
	  ("%edx" reg i32 4 nil)
	  ("%ebx" reg i32 4 nil)
	  ("%esi" reg i32 4 nil)
	  ("%edi" reg i32 4 nil)
	  ("%ebp" reg i32 4 nil)
	  ("%esp" reg i32 4 nil)))
    (def *reg-i32*
	 ((reg i32 "%eax")
	  (reg i32 "%ecx")
	  (reg i32 "%edx")
	  (reg i32 "%ebx")
	  (reg i32 "%esi")
	  (reg i32 "%edi")))
    (def *reg-i16*
	 ((subreg i16
		  (reg i32 "%eax")
		  0)
	  (subreg i16
		  (reg i32 "%ecx")
		  0)
	  (subreg i16
		  (reg i32 "%edx")
		  0)
	  (subreg i16
		  (reg i32 "%ebx")
		  0)
	  (subreg i16
		  (reg i32 "%esi")
		  0)
	  (subreg i16
		  (reg i32 "%edi")
		  0)))
    (def *reg-i8*
	 ((subreg i8
		  (reg i32 "%eax")
		  0)
	  (subreg i8
		  (reg i32 "%ecx")
		  0)
	  (subreg i8
		  (reg i32 "%edx")
		  0)
	  (subreg i8
		  (reg i32 "%ebx")
		  0)))
    (def *reg-eax-i32*
	 ((reg i32 "%eax")))
    (def *reg-ecx-i32*
	 ((reg i32 "%ecx")))
    (def *reg-edx-i32*
	 ((reg i32 "%edx")))
    (def *reg-mod$2-i32*
	 ((reg i32 "%eax")
	  (reg i32 "%ecx")
	  (reg i32 "%ebx")
	  (reg i32 "%esi")
	  (reg i32 "%edi")))
    (def *reg-call-clobbers*
	 ((reg i32 "%eax")
	  (reg i32 "%ecx")
	  (reg i32 "%edx")))))
(dolist
    (def sck=tmd-def-form-list)
  (put
   (cadr def)
   'def
   (caddr def)))

(put 'reg 'defregset
     '((i32 *reg-i32*)
       (i16 *reg-i16*)
       (i8 *reg-i8*)))


(defconst sck=tmd-rule-list
  '([cl-struct-sck-tmd-rule reg reg
			    (reg
			     ($ -1)
			     ($ -1))
			    nil 0
			    (asmarg
			     (sck-tmd-x86-regname
			      ($ 0)))
			    nil nil nil nil nil]
    [cl-struct-sck-tmd-rule reg-subreg reg
			    (subreg
			     ($ -1)
			     ($ -1)
			     ($ -1))
			    nil 0
			    (asmarg
			     (sck-tmd-x86-regname
			      ($ 0)))
			    nil nil nil nil nil]
    [cl-struct-sck-tmd-rule con con
			    (iconst
			     ($ -1)
			     ($ -1))
			    nil 0
			    (asmarg
			     `(con ,(caddr
				     ($ 0))))
			    nil nil nil nil nil]
    [cl-struct-sck-tmd-rule sta sta
			    (static i32
				    ($ -1))
			    nil 0
			    (asmarg
			     `(sta ,(caddr
				     ($ 0))))
			    nil nil nil nil nil]
    [cl-struct-sck-tmd-rule cs-con cs
			    ($ 0 con)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 con))
			    nil]
    [cl-struct-sck-tmd-rule cs-sta cs
			    ($ 0 sta)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 sta))
			    nil]
    [cl-struct-sck-tmd-rule lab lab
			    (label i32
				   ($ -1))
			    nil 0
			    (asmarg
			     `(lab ,(caddr
				     ($ 0))))
			    nil nil nil nil nil]
    [cl-struct-sck-tmd-rule base-cs base
			    ($ 0 cs)
			    nil 0
			    (asmarg
			     `(base ,($ 1)
				    nil))
			    nil nil nil
			    (($ 0 cs))
			    nil]
    [cl-struct-sck-tmd-rule base-reg base
			    ($ 0 reg)
			    nil 0
			    (asmarg
			     `(base nil ,($ 1)))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule base-csreg base
			    (add i32
				 ($ 0 reg)
				 ($ 1 cs))
			    nil 0
			    (asmarg
			     `(base ,($ 2)
				    ,($ 1)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 cs))
			    nil]
    [cl-struct-sck-tmd-rule index-1 index
			    ($ 0 reg)
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     1))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-2 index
			    (mul i32
				 ($ 0 reg)
				 (iconst i32 2))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     2))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-4 index
			    (mul i32
				 ($ 0 reg)
				 (iconst i32 4))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     4))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-8 index
			    (mul i32
				 ($ 0 reg)
				 (iconst i32 8))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     8))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-<<1 index
			    (lshs i32
				  ($ 0 reg)
				  (iconst i32 1))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     2))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-<<2 index
			    (lshs i32
				  ($ 0 reg)
				  (iconst i32 2))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     4))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule index-<<3 index
			    (lshs i32
				  ($ 0 reg)
				  (iconst i32 3))
			    nil 0
			    (asmarg
			     `(index ,($ 1)
				     8))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule addr-base addr
			    ($ 0 base)
			    nil 0
			    (asmarg
			     `(addr ,($ 1)
				    nil))
			    nil nil nil
			    (($ 0 base))
			    nil]
    [cl-struct-sck-tmd-rule addr-index addr
			    ($ 0 index)
			    nil 0
			    (asmarg
			     `(addr nil ,($ 1)))
			    nil nil nil
			    (($ 0 index))
			    nil]
    [cl-struct-sck-tmd-rule addr-baseindex addr
			    (add i32
				 ($ 0 base)
				 ($ 1 index))
			    nil 0
			    (asmarg
			     `(addr ,($ 1)
				    ,($ 2)))
			    nil nil nil
			    (($ 0 base)
			     ($ 1 index))
			    nil]
    [cl-struct-sck-tmd-rule mem-i32 mem
			    (mem i32
				 ($ 0 addr))
			    nil 0
			    (asmarg
			     `(mem long ,($ 1)))
			    nil nil nil
			    (($ 0 addr))
			    nil]
    [cl-struct-sck-tmd-rule mem-i16 mem
			    (mem i16
				 ($ 0 addr))
			    nil 0
			    (asmarg
			     `(mem word ,($ 1)))
			    nil nil nil
			    (($ 0 addr))
			    nil]
    [cl-struct-sck-tmd-rule mem-i8 mem
			    (mem i8
				 ($ 0 addr))
			    nil 0
			    (asmarg
			     `(mem byte ,($ 1)))
			    nil nil nil
			    (($ 0 addr))
			    nil]
    [cl-struct-sck-tmd-rule mr-reg mr
			    ($ 0 reg)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule mr-mem mr
			    ($ 0 mem)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 mem))
			    nil]
    [cl-struct-sck-tmd-rule rc-reg rc
			    ($ 0 reg)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule rc-con rc
			    ($ 0 con)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 con))
			    nil]
    [cl-struct-sck-tmd-rule mrc0-mem mrc0
			    ($ 0 mem)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 mem))
			    nil]
    [cl-struct-sck-tmd-rule mrc0-rc mrc0
			    ($ 0 rc)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 rc))
			    nil]
    [cl-struct-sck-tmd-rule mrc1-mem mrc1
			    ($ 0 mem)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 mem))
			    nil]
    [cl-struct-sck-tmd-rule mrc1-rc mrc1
			    ($ 0 rc)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 rc))
			    nil]
    [cl-struct-sck-tmd-rule mrc3-mem mrc3
			    ($ 0 mem)
			    nil 3
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 mem))
			    nil]
    [cl-struct-sck-tmd-rule mrc3-rc mrc3
			    ($ 0 rc)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 rc))
			    nil]
    [cl-struct-sck-tmd-rule callarg-sta callarg
			    ($ 0 sta)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 sta))
			    nil]
    [cl-struct-sck-tmd-rule callarg-reg callarg
			    ($ 0 reg)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 reg))
			    nil]
    [cl-struct-sck-tmd-rule callarg-mem callarg
			    ($ 0 mem)
			    nil 0
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 0 mem))
			    nil]
    [cl-struct-sck-tmd-rule move-i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movl ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule move-i32/reg reg
			    ($ 1 rc)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 rc))
			    i32]
    [cl-struct-sck-tmd-rule move-i16/stmt stmt
			    (set i16
				 ($ 0 reg)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movw ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule move-i16/reg reg
			    ($ 1 rc)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 rc))
			    i16]
    [cl-struct-sck-tmd-rule move-i8/stmt stmt
			    (set i8
				 ($ 0 reg)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movb ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule move-i8/reg reg
			    ($ 1 rc)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 rc))
			    i8]
    [cl-struct-sck-tmd-rule leal/stmt stmt
			    (set i32
				 ($ 0 reg)
				 ($ 1 addr))
			    nil 1
			    (asminst
			     `(leal ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 addr))
			    nil]
    [cl-struct-sck-tmd-rule leal/reg reg
			    ($ 1 addr)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 addr))
			    i32]
    [cl-struct-sck-tmd-rule load-i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 ($ 1 mem))
			    nil 1
			    (asminst
			     `(movl ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mem))
			    nil]
    [cl-struct-sck-tmd-rule load-i32/reg reg
			    ($ 1 mem)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 mem))
			    i32]
    [cl-struct-sck-tmd-rule load-i16/stmt stmt
			    (set i16
				 ($ 0 reg)
				 ($ 1 mem))
			    nil 1
			    (asminst
			     `(movw ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mem))
			    nil]
    [cl-struct-sck-tmd-rule load-i16/reg reg
			    ($ 1 mem)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 mem))
			    i16]
    [cl-struct-sck-tmd-rule load-i8/stmt stmt
			    (set i8
				 ($ 0 reg)
				 ($ 1 mem))
			    nil 1
			    (asminst
			     `(movb ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mem))
			    nil]
    [cl-struct-sck-tmd-rule load-i8/reg reg
			    ($ 1 mem)
			    nil 1
			    (asmarg
			     ($ 1))
			    nil nil nil
			    (($ 1 mem))
			    i8]
    [cl-struct-sck-tmd-rule store-i32/stmt stmt
			    (set i32
				 ($ 0 mem)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movl ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 mem)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule store-i16/stmt stmt
			    (set i16
				 ($ 0 mem)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movw ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 mem)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule store-i8/stmt stmt
			    (set i8
				 ($ 0 mem)
				 ($ 1 rc))
			    nil 1
			    (asminst
			     `(movb ,($ 1)
				    ,($ 0)))
			    nil nil nil
			    (($ 0 mem)
			     ($ 1 rc))
			    nil]
    [cl-struct-sck-tmd-rule push-i32/stmt stmt
			    (parallel
			     (set i32
				  (mem i32
				       (sub i32
					    (reg i32 "%esp")
					    (iconst i32 4)))
				  ($ 0 mrc3))
			     (set i32
				  (reg i32 "%esp")
				  (sub i32
				       (reg i32 "%esp")
				       (iconst i32 4))))
			    nil 1
			    (asminst
			     `(pushl ,($ 0)))
			    nil nil nil
			    (($ 0 mrc3))
			    nil]
    [cl-struct-sck-tmd-rule addl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (add i32
				      ($ 1 reg)
				      ($ 2 mrc1)))
			    nil 2
			    (asminst
			     `(addl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule addl/reg reg
			    (add i32
				 ($ 1 reg)
				 ($ 2 mrc1))
			    nil 2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule subl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (sub i32
				      ($ 1 reg)
				      ($ 2 mrc1)))
			    nil 2
			    (asminst
			     `(subl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule subl/reg reg
			    (sub i32
				 ($ 1 reg)
				 ($ 2 mrc1))
			    nil 2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule andl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (band i32
				       ($ 1 reg)
				       ($ 2 mrc1)))
			    nil 2
			    (asminst
			     `(andl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule andl/reg reg
			    (band i32
				  ($ 1 reg)
				  ($ 2 mrc1))
			    nil 2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule orl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (bor i32
				      ($ 1 reg)
				      ($ 2 mrc1)))
			    nil 2
			    (asminst
			     `(orl ,($ 2)
				   ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule orl/reg reg
			    (bor i32
				 ($ 1 reg)
				 ($ 2 mrc1))
			    nil 2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule xorl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (bxor i32
				       ($ 1 reg)
				       ($ 2 mrc1)))
			    nil 2
			    (asminst
			     `(xorl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule xorl/reg reg
			    (bxor i32
				  ($ 1 reg)
				  ($ 2 mrc1))
			    nil 2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc1))
			    nil]
    [cl-struct-sck-tmd-rule negl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (neg i32
				      ($ 1 reg)))
			    nil 2
			    (asminst
			     `(negl ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule negl/reg reg
			    (neg i32
				 ($ 1 reg))
			    nil 2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule notl/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (bnot i32
				       ($ 1 reg)))
			    nil 2
			    (asminst
			     `(notl ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule notl/reg reg
			    (bnot i32
				  ($ 1 reg))
			    nil 2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule sall-con/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (lshs i32
				       ($ 1 reg)
				       ($ 2 con)))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2
			    (asminst
			     `(sall ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule sall-con/reg reg
			    (lshs i32
				  ($ 1 reg)
				  ($ 2 con))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule shll-con/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (lshu i32
				       ($ 1 reg)
				       ($ 2 con)))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2
			    (asminst
			     `(shll ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule shll-con/reg reg
			    (lshu i32
				  ($ 1 reg)
				  ($ 2 con))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule sarl-con/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (rshs i32
				       ($ 1 reg)
				       ($ 2 con)))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2
			    (asminst
			     `(sarl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule sarl-con/reg reg
			    (rshs i32
				  ($ 1 reg)
				  ($ 2 con))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule shrl-con/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (rshu i32
				       ($ 1 reg)
				       ($ 2 con)))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2
			    (asminst
			     `(shrl ,($ 2)
				    ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule shrl-con/reg reg
			    (rshu i32
				  ($ 1 reg)
				  ($ 2 con))
			    (and
			     (<= 0
				 (caddr
				  ($ 2)))
			     (<=
			      (caddr
			       ($ 2))
			      31))
			    2 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 con))
			    nil]
    [cl-struct-sck-tmd-rule sall-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (lshs i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 1
			    (asminst
			     `(sall
			       (reg "%cl")
			       ,($ 0)))
			    ((2 *reg-ecx-i32*))
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule sall-reg/reg reg
			    (lshs i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 1 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule shll-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (lshu i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 1
			    (asminst
			     `(shll
			       (reg "%cl")
			       ,($ 0)))
			    ((2 *reg-ecx-i32*))
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule shll-reg/reg reg
			    (lshu i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 1 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule sarl-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (rshs i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 1
			    (asminst
			     `(sarl
			       (reg "%cl")
			       ,($ 0)))
			    ((2 *reg-ecx-i32*))
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule sarl-reg/reg reg
			    (rshs i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 1 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule shrl-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (rshu i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 1
			    (asminst
			     `(shrl
			       (reg "%cl")
			       ,($ 0)))
			    ((2 *reg-ecx-i32*))
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule shrl-reg/reg reg
			    (rshu i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 1 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule mul-mrc3/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (mul i32
				      ($ 1 reg)
				      ($ 2 mrc3)))
			    nil 14
			    (asminst
			     `(imull ,($ 2)
				     ,($ 0)))
			    nil
			    ((0 1))
			    nil
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 mrc3))
			    nil]
    [cl-struct-sck-tmd-rule mul-mrc3/reg reg
			    (mul i32
				 ($ 1 reg)
				 ($ 2 mrc3))
			    nil 14 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 mrc3))
			    nil]
    [cl-struct-sck-tmd-rule divs-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (divs i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 14
			    (asminst
			     `(cdq)
			     `(idivl ,($ 2)))
			    ((0 *reg-eax-i32*))
			    ((0 1))
			    ((reg i32 "%edx"))
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule divs-reg/reg reg
			    (divs i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 14 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule divu-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (divu i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 14
			    (asminst
			     `(xorl
			       (reg "%edx")
			       (reg "%edx"))
			     `(idivl ,($ 2)))
			    ((0 *reg-eax-i32*))
			    ((0 1))
			    ((reg i32 "%edx"))
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule divu-reg/reg reg
			    (divu i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 14 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule mods-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (mods i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 14
			    (asminst
			     `(cdq)
			     `(idivl ,($ 2)))
			    ((1 *reg-eax-i32*)
			     (0 *reg-edx-i32*)
			     (2 *reg-mod$2-i32*))
			    nil
			    ((reg i32 "%eax"))
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule mods-reg/reg reg
			    (mods i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 14 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule modu-reg/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (modu i32
				       ($ 1 reg)
				       ($ 2 reg)))
			    nil 14
			    (asminst
			     `(xorl
			       (reg "%edx")
			       (reg "%edx"))
			     `(idivl ,($ 2)))
			    ((1 *reg-eax-i32*)
			     (0 *reg-edx-i32*)
			     (2 *reg-mod$2-i32*))
			    nil
			    ((reg i32 "%eax"))
			    (($ 0 reg)
			     ($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule modu-reg/reg reg
			    (modu i32
				  ($ 1 reg)
				  ($ 2 reg))
			    nil 14 nil nil nil nil
			    (($ 1 reg)
			     ($ 2 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i8->i16/stmt stmt
			    (set i16
				 ($ 0 reg)
				 (convsx i16
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2
			    (asminst
			     `(movsbw ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i8->i16/reg reg
			    (convsx i16
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i8->i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (convsx i32
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2
			    (asminst
			     `(movsbl ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i8->i32/reg reg
			    (convsx i32
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i16->i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (convsx i32
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2
			    (asminst
			     `(movswl ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convsx-i16->i32/reg reg
			    (convsx i32
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i8->i16/stmt stmt
			    (set i16
				 ($ 0 reg)
				 (convzx i16
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2
			    (asminst
			     `(movzbw ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i8->i16/reg reg
			    (convzx i16
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i8->i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (convzx i32
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2
			    (asminst
			     `(movzbl ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i8->i32/reg reg
			    (convzx i32
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i8)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i16->i32/stmt stmt
			    (set i32
				 ($ 0 reg)
				 (convzx i32
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2
			    (asminst
			     `(movzwl ,($ 1)
				      ,($ 0)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convzx-i16->i32/reg reg
			    (convzx i32
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i32->i16/stmt stmt
			    (set i16
				 ($ 0 reg)
				 (convit i16
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i32)
			    2
			    (asminst
			     (let
				 ((srcreg
				   (cadr
				    ($ 1)))
				  (dstreg
				   (cadr
				    ($ 0))))
			       (if
				   (and
				    (eq 'i16 'i8)
				    (member srcreg
					    '("%esi" "%edi")))
				   `(movl
				     (reg ,srcreg)
				     (reg ,(sck-tmd-x86-subregname dstreg 'i32)))
				 `(movw
				   (reg ,(sck-tmd-x86-subregname srcreg 'i16))
				   (reg ,dstreg)))))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i32->i16/reg reg
			    (convit i16
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i32)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i32->i8/stmt stmt
			    (set i8
				 ($ 0 reg)
				 (convit i8
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i32)
			    2
			    (asminst
			     (let
				 ((srcreg
				   (cadr
				    ($ 1)))
				  (dstreg
				   (cadr
				    ($ 0))))
			       (if
				   (and
				    (eq 'i8 'i8)
				    (member srcreg
					    '("%esi" "%edi")))
				   `(movl
				     (reg ,srcreg)
				     (reg ,(sck-tmd-x86-subregname dstreg 'i32)))
				 `(movb
				   (reg ,(sck-tmd-x86-subregname srcreg 'i8))
				   (reg ,dstreg)))))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i32->i8/reg reg
			    (convit i8
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i32)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i16->i8/stmt stmt
			    (set i8
				 ($ 0 reg)
				 (convit i8
					 ($ 1 reg)))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2
			    (asminst
			     (let
				 ((srcreg
				   (cadr
				    ($ 1)))
				  (dstreg
				   (cadr
				    ($ 0))))
			       (if
				   (and
				    (eq 'i8 'i8)
				    (member srcreg
					    '("%esi" "%edi")))
				   `(movl
				     (reg ,srcreg)
				     (reg ,(sck-tmd-x86-subregname dstreg 'i32)))
				 `(movb
				   (reg ,(sck-tmd-x86-subregname srcreg 'i8))
				   (reg ,dstreg)))))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule convit-i16->i8/reg reg
			    (convit i8
				    ($ 1 reg))
			    (eq
			     (sck-lir-type
			      ($ 1))
			     'i16)
			    2 nil nil nil nil
			    (($ 1 reg))
			    nil]
    [cl-struct-sck-tmd-rule jump/stmt stmt
			    (jump
			     ($ 0 lab))
			    nil 3
			    (asminst
			     `(jmp ,($ 0)))
			    nil nil nil
			    (($ 0 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-eq-mrc1-i32/stmt stmt
			    (jumpc
			     (tsteq i32
				    ($ 0 reg)
				    ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(je ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-ne-mrc1-i32/stmt stmt
			    (jumpc
			     (tstne i32
				    ($ 0 reg)
				    ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jne ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-lts-mrc1-i32/stmt stmt
			    (jumpc
			     (tstlts i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jl ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-les-mrc1-i32/stmt stmt
			    (jumpc
			     (tstles i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jle ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-gts-mrc1-i32/stmt stmt
			    (jumpc
			     (tstgts i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jg ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-ges-mrc1-i32/stmt stmt
			    (jumpc
			     (tstges i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jge ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-ltu-mrc1-i32/stmt stmt
			    (jumpc
			     (tstltu i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jb ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-leu-mrc1-i32/stmt stmt
			    (jumpc
			     (tstleu i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jbe ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-gtu-mrc1-i32/stmt stmt
			    (jumpc
			     (tstgtu i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(ja ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule jumpc-geu-mrc1-i32/stmt stmt
			    (jumpc
			     (tstgeu i32
				     ($ 0 reg)
				     ($ 1 mrc1))
			     ($ 2 lab)
			     ($ 3 lab))
			    (eq
			     (sck-lir-type
			      ($ 0))
			     'i32)
			    4
			    (asminst
			     `(cmpl ,($ 1)
				    ,($ 0))
			     `(jae ,($ 2)))
			    nil nil nil
			    (($ 0 reg)
			     ($ 1 mrc1)
			     ($ 2 lab)
			     ($ 3 lab))
			    nil]
    [cl-struct-sck-tmd-rule call/stmt stmt
			    (call
			     ($ 0 callarg))
			    nil 4
			    (asminst
			     `(call ,($ 0)))
			    nil nil nil
			    (($ 0 callarg))
			    nil]))
(dolist
    (r sck=tmd-rule-list)
  (put
   (sck-tmd-rule-name r)
   'rule r))


(defconst sck=tmd-chain-rule-alist
  '((con cs-con rc-con)
    (sta cs-sta callarg-sta)
    (cs base-cs)
    (reg base-reg index-1 mr-reg rc-reg callarg-reg)
    (base addr-base)
    (index addr-index)
    (mem mr-mem mrc0-mem mrc1-mem mrc3-mem callarg-mem load-i32/reg load-i16/reg load-i8/reg)
    (rc mrc0-rc mrc1-rc mrc3-rc move-i32/reg move-i16/reg move-i8/reg)
    (addr leal/reg)))

(defun sck-tmd-x86-reg
  (type name)
  (case
      (sck-lir-type-kind type)
    (integral
     (copy-tree
      (let
	  ((reg
	    `(reg i32 ,name)))
	(if
	    (=
	     (sck-lir-type-bits type)
	     32)
	    reg
	  `(subreg ,type ,reg 0)))))
    (t
     (assert nil))))

(defun sck-tmd-make-push-exp
  (exp)
  (let
      ((type
	(sck-lir-type exp)))
    (copy-tree
     `(parallel
       (set ,type
	    (mem ,type
		 (sub i32
		      (reg i32 "%esp")
		      (iconst i32 4)))
	    ,exp)
       (set i32
	    (reg i32 "%esp")
	    (sub i32
		 (reg i32 "%esp")
		 (iconst i32 4)))))))

(defun sck-tmd-restruct-prologue
  (exp lsymtab)
  (let
      ((org-args
	(cdr exp))
       (act-to-org-exps
	(make-que))
       (act-offset
	(+ 16 4)))
    (dolist
	(arg org-args)
      (let
	  ((type
	    (sck-lir-type arg)))
	(case
	    (sck-lir-type-kind type)
	  (integral
	   (append-que act-to-org-exps
			 (copy-tree
			  `(set ,type ,arg
				(mem ,type
				     (add i32
					  (reg i32 "%ebp")
					  (iconst i32 ,act-offset)))))))
	  (t
	   (assert nil)))
	(incf act-offset
	      (roundup
	       (sck-lir-type-bytes type)
	       4))))
    (setq act-to-org-exps
	  (que-to-list act-to-org-exps))
    (copy-tree
     `((prologue)
       ,@act-to-org-exps))))

(defun sck-tmd-restruct-epilogue
  (exp lsymtab)
  (let
      ((rets
	(cdr exp)))
    (cond
     ((null rets)
      (list exp))
     ((= 1
	 (length rets))
      (let*
	  ((ret
	    (car rets))
	   (type
	    (sck-lir-type ret)))
	(case
	    (sck-lir-type-kind type)
	  (integral
	   (let
	       ((reg
		 (sck-tmd-x86-reg type "%eax")))
	     (copy-tree
	      (list
	       `(set ,type ,reg ,ret)
	       `(epilogue ,reg)))))
	  (t
	   (assert nil)))))
     (t
      (assert nil)))))

(defun sck-tmd-restruct-call
  (exp lsymtab)
  (let
      ((func-exp
	(elt exp 1))
       (org-args
	(elt exp 2))
       (org-ret
	(car
	 (elt exp 3)))
       (act-retreg nil)
       (push-arg-exps
	(make-que)))
    (dolist
	(arg
	 (reverse org-args))
      (let
	  ((type
	    (sck-lir-type arg)))
	(case
	    (sck-lir-type-kind type)
	  (integral
	   (unless
	       (eq type 'i32)
	     (setq arg
		   `(convzx I32 ,arg)))
	   (append-que push-arg-exps
			 (sck-tmd-make-push-exp arg)))
	  (t
	   (assert nil)))))
    (setq push-arg-exps
	  (que-to-list push-arg-exps))
    (when org-ret
      (let
	  ((type
	    (sck-lir-type org-ret)))
	(setq act-retreg
	      (case
		  (sck-lir-type-kind type)
		(integral
		 (sck-tmd-x86-reg type "%eax"))
		(t
		 (assert nil))))))
    (copy-tree
     `(,@push-arg-exps
       (parallel
	(call ,func-exp nil ,(if
				 (null org-ret)
				 nil
			       (list act-retreg)))
	(clobber *reg-call-clobbers*))
       (set i32
	    (reg i32 "%esp")
	    (add i32
		 (reg i32 "%esp")
		 (iconst i32 ,(* 4
				 (length org-args)))))
       ,@(if
	     (null org-ret)
	     nil
	   `((set ,(sck-lir-type org-ret)
		  ,org-ret ,act-retreg)))))))

(defun sck-tmd-restruct-frame
  (frame-exp offset)
  (copy-tree
   `(add i32
	 (reg i32 "%ebp")
	 (iconst i32 ,offset))))

(defun sck-tmd-x86-regname
  (exp)
  (let
      ((name
	(sck-lir-reg-name exp))
       (type
	(sck-lir-type exp)))
    (ecase
	(car exp)
      (reg
       `(reg ,name))
      (subreg
       (case
	   (aref name 0)
	 (37
	  `(reg ,(sck-tmd-x86-subregname name type)))
	 (t
	  `(reg ,(format "%s/%s" name type))))))))

(defun sck-tmd-x86-subregname
  (name type)
  (let
      ((sname
	(elt
	 (assoc name
		'(("%eax" "%ax" "%al")
		  ("%ecx" "%cx" "%cl")
		  ("%edx" "%dx" "%dl")
		  ("%ebx" "%bx" "%bl")
		  ("%esi" "%si")
		  ("%edi" "%di")))
	 (ecase type
	   (i32 0)
	   (i16 1)
	   (i8 2)))))
    (assert sname)
    sname))

(defun sck-tmd-asmout-emit-comment
  (fmt &rest args)
  (insertf "# %s\n"
	   (apply 'format fmt args)))

(defun sck-tmd-asmout-emit-beginning-of-module nil)

(defun sck-tmd-asmout-emit-end-of-module nil)

(defun sck-tmd-asmout-emit-beginning-of-segment
  (segment))

(defun sck-tmd-asmout-emit-end-of-segment
  (segment))

(defun sck-tmd-asmout-emit-align
  (n)
  (insertf "	.align	%d\n" n))

(defun sck-tmd-asmout-emit-common
  (name size align linkage)
  (ecase linkage
    ((xdef)
     (insertf "	.comm	_%s, %d\n" name
	      (roundup size 16)))
    ((ldef)
     (insertf "	.lcomm	_%s, %d\n" name
	      (roundup size 16)))))

(defun sck-tmd-asmout-emit-zeros
  (n)
  (insertf "	.zero	%d\n" n))

(defun sck-tmd-asmout-emit-linkage
  (name linkage)
  (setq name
	(if
	    (equal name "main")
	    "_sck_main" name))
  (case linkage
    ((xdef)
     (insertf "	.globl	_%s\n" name))
    ((ldef))
    ((xref))))

(defun sck-tmd-asmout-emit-data
  (type data)
  (case type
    ((i32)
     (insertf "	.long	%s\n" data))
    ((i16)
     (insertf "	.word	%s\n" data))
    ((i8)
     (insertf "	.byte	%s\n" data))
    (t
     (assert nil))))

(defun sck-tmd-asmout-emit-function-label
  (label)
  (setq label
	(if
	    (equal label "main")
	    "_sck_main" label))
  (insertf "_%s:\n" label))

(defun sck-tmd-asmout-emit-jump-label
  (label)
  (insertf "%s:\n" label))

(defun sck-tmd-asmout-emit-data-label
  (label)
  (insertf "_%s:\n" label))

(defun sck-tmd-asmout-framesize
  (lfunc)
  (let
      ((lsymtab
	(caddr lfunc)))
    (roundup
     (sck-lir-lsymtab-frame-size lsymtab)
     4)))

(defun sck-tmd-asmout-emit-prologue
  (framesize)
  (insertf "	pushl	%%ebx\n")
  (insertf "	pushl	%%esi\n")
  (insertf "	pushl	%%edi\n")
  (insertf "	pushl	%%ebp\n")
  (insertf "	movl	%%esp,%%ebp\n")
  (when
      (< 0 framesize)
    (insertf "	subl	$%d,%%esp\n" framesize)))

(defun sck-tmd-asmout-emit-epilogue
  (framesize)
  (insertf "	movl	%%ebp,%%esp\n")
  (insertf "	popl	%%ebp\n")
  (insertf "	popl	%%edi\n")
  (insertf "	popl	%%esi\n")
  (insertf "	popl	%%ebx\n")
  (insertf "	ret\n"))

(defun sck-tmd-asmout-conv-arg
  (arg)
  (if
      (null arg)
      ""
    (case
	(car arg)
      ((con)
       (format "$%S"
	       (cadr arg)))
      ((sta)
       (format "_%s"
	       (cadr arg)))
      ((reg lab)
       (cadr arg))
      ((addr)
       (sck-tmd-asmout-conv-arg/addr arg))
      ((mem)
       (sck-tmd-asmout-conv-arg/mem arg))
      (t
       (error "tmd-asmout-conv-arg: illegal argument: %S" arg)))))

(defun sck-tmd-asmout-conv-arg/mem
  (mem)
  (sck-tmd-asmout-conv-arg/addr
   (caddr mem)))

(defun sck-tmd-asmout-conv-arg/addr
  (addr)
  (let*
      ((base
	(cadr addr))
       (index
	(caddr addr))
       (base-cs
	(cadr base))
       (base-reg
	(caddr base))
       (index-reg
	(cadr index))
       (index-n
	(caddr index)))
    (concat
     (if
	 (null base-cs)
	 ""
       (if
	   (eq
	    (car base-cs)
	    'con)
	   (format "%S"
		   (cadr base-cs))
	 (sck-tmd-asmout-conv-arg base-cs)))
     (if
	 (and
	  (null base-reg)
	  (null index))
	 ""
       (concat "("
	       (sck-tmd-asmout-conv-arg base-reg)
	       (if
		   (null index-reg)
		   ""
		 (concat ","
			 (sck-tmd-asmout-conv-arg index-reg)
			 (if
			     (= 1 index-n)
			     ""
			   (format ",%d" index-n))))
	       ")")))))

(defun sck-tmd-asmout-conv-asmconst-exp
  (exp)
  "AZuiJj萔𕶎ɕϊB"
  (assert
   (sck-lir-typed-exp-p exp))
  (let
      ((op
	(car exp))
       (args
	(sck-lir-args exp)))
    (case op
      ((iconst fconst)
       (caddr exp))
      ((static)
       (format "_%s"
	       (caddr exp)))
      ((add sub)
       (let
	   ((xop
	     (car
	      (car args)))
	    (yop
	     (car
	      (cadr args))))
	 (if
	     (member
	      (list xop op yop)
	      '((static add iconst)
		(static sub iconst)
		(iconst add static)
		(static sub static)))
	     (message "%s%c%s"
		      (sck-tmd-asmout-conv-asmconst-exp
		       (car args))
		      (if
			  (eq op 'add)
			  43 45)
		      (sck-tmd-asmout-conv-asmconst-exp
		       (cadr args)))
	   (error "sck-tmd-asmout-conv-asmconst-exp: illegal exp: %S" exp))))
      (t
       (error "sck-tmd-asmout-conv-asmconst-exp: illegal exp: %S" exp)))))

(defun sck-tmd-matcher (x)
  (case (car x)
    ((reg)
     (sck-tmd-tiling-exp-action x (quote reg) []))
    ((subreg)
     (sck-tmd-tiling-exp-action x (quote reg-subreg) []))
    ((iconst)
     (sck-tmd-tiling-exp-action x (quote con) []))
    ((static)
     (when (eq (cadr x) 'i32)
       (sck-tmd-tiling-exp-action x (quote sta) [])))
    ((label)
     (when (eq (cadr x) 'i32)
       (sck-tmd-tiling-exp-action x (quote lab) [])))
    ((mem)
     (case (cadr x)
       ((i32)
        (when (sck-tmd-exp-tile (caddr x) (quote addr))
          (sck-tmd-tiling-exp-action x (quote mem-i32) (vector (cddr x)))))
       ((i16)
        (when (sck-tmd-exp-tile (caddr x) (quote addr))
          (sck-tmd-tiling-exp-action x (quote mem-i16) (vector (cddr x)))))
       ((i8)
        (when (sck-tmd-exp-tile (caddr x) (quote addr))
          (sck-tmd-tiling-exp-action x (quote mem-i8) (vector (cddr x)))))))
    ((parallel)
     (when (eq (car (cadr x)) 'set)
       (when (eq (cadr (cadr x)) 'i32)
         (when (eq (car (caddr (cadr x))) 'mem)
           (when (eq (cadr (caddr (cadr x))) 'i32)
             (when (eq (car (caddr (caddr (cadr x)))) 'sub)
               (when (eq (cadr (caddr (caddr (cadr x)))) 'i32)
                 (when (eq (car (caddr (caddr (caddr (cadr x))))) 'reg)
                   (when (eq (cadr (caddr (caddr (caddr (cadr x))))) 'i32)
                     (when (equal (caddr (caddr (caddr (caddr (cadr x))))) "%esp")
                       (when (eq (car (cadddr (caddr (caddr (cadr x))))) 'iconst)
                         (when (eq (cadr (cadddr (caddr (caddr (cadr x))))) 'i32)
                           (when (equal (caddr (cadddr (caddr (caddr (cadr x))))) 4)
                             (when (eq (car (caddr x)) 'set)
                               (when (eq (cadr (caddr x)) 'i32)
                                 (when (eq (car (caddr (caddr x))) 'reg)
                                   (when (eq (cadr (caddr (caddr x))) 'i32)
                                     (when (equal (caddr (caddr (caddr x))) "%esp")
                                       (when (eq (car (cadddr (caddr x))) 'sub)
                                         (when (eq (cadr (cadddr (caddr x))) 'i32)
                                           (when (eq (car (caddr (cadddr (caddr x)))) 'reg)
                                             (when (eq (cadr (caddr (cadddr (caddr x)))) 'i32)
                                               (when (equal (caddr (caddr (cadddr (caddr x)))) "%esp")
                                                 (when (eq (car (cadddr (cadddr (caddr x)))) 'iconst)
                                                   (when (eq (cadr (cadddr (cadddr (caddr x)))) 'i32)
                                                     (when (equal (caddr (cadddr (cadddr (caddr x)))) 4)
                                                       (when (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc3))
                                                         (sck-tmd-tiling-exp-action x (quote push-i32/stmt) (vector (cdddr (cadr x)))))))))))))))))))))))))))))))
    ((add)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote cs)))
         (sck-tmd-tiling-exp-action x (quote base-csreg) (vector (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote base)) (sck-tmd-exp-tile (cadddr x) (quote index)))
         (sck-tmd-tiling-exp-action x (quote addr-baseindex) (vector (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc1)))
         (sck-tmd-tiling-exp-action x (quote addl/reg) (vector nil (cddr x) (cdddr x))))))
    ((sub)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc1)))
         (sck-tmd-tiling-exp-action x (quote subl/reg) (vector nil (cddr x) (cdddr x))))))
    ((band)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc1)))
         (sck-tmd-tiling-exp-action x (quote andl/reg) (vector nil (cddr x) (cdddr x))))))
    ((bor)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc1)))
         (sck-tmd-tiling-exp-action x (quote orl/reg) (vector nil (cddr x) (cdddr x))))))
    ((bxor)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc1)))
         (sck-tmd-tiling-exp-action x (quote xorl/reg) (vector nil (cddr x) (cdddr x))))))
    ((neg)
     (when (eq (cadr x) 'i32)
       (when (sck-tmd-exp-tile (caddr x) (quote reg))
         (sck-tmd-tiling-exp-action x (quote negl/reg) (vector nil (cddr x))))))
    ((bnot)
     (when (eq (cadr x) 'i32)
       (when (sck-tmd-exp-tile (caddr x) (quote reg))
         (sck-tmd-tiling-exp-action x (quote notl/reg) (vector nil (cddr x))))))
    ((lshs)
     (when (eq (cadr x) 'i32)
       (when (eq (car (cadddr x)) 'iconst)
         (when (eq (cadr (cadddr x)) 'i32)
           (case (caddr (cadddr x))
             ((1)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-<<1) (vector (cddr x)))))
             ((2)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-<<2) (vector (cddr x)))))
             ((3)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-<<3) (vector (cddr x))))))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote con)))
         (sck-tmd-tiling-exp-action x (quote sall-con/reg) (vector nil (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote sall-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((lshu)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote con)))
         (sck-tmd-tiling-exp-action x (quote shll-con/reg) (vector nil (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote shll-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((rshs)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote con)))
         (sck-tmd-tiling-exp-action x (quote sarl-con/reg) (vector nil (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote sarl-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((rshu)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote con)))
         (sck-tmd-tiling-exp-action x (quote shrl-con/reg) (vector nil (cddr x) (cdddr x))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote shrl-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((mul)
     (when (eq (cadr x) 'i32)
       (when (eq (car (cadddr x)) 'iconst)
         (when (eq (cadr (cadddr x)) 'i32)
           (case (caddr (cadddr x))
             ((2)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-2) (vector (cddr x)))))
             ((4)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-4) (vector (cddr x)))))
             ((8)
              (when (sck-tmd-exp-tile (caddr x) (quote reg))
                (sck-tmd-tiling-exp-action x (quote index-8) (vector (cddr x))))))))
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mrc3)))
         (sck-tmd-tiling-exp-action x (quote mul-mrc3/reg) (vector nil (cddr x) (cdddr x))))))
    ((divs)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote divs-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((divu)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote divu-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((mods)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote mods-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((modu)
     (when (eq (cadr x) 'i32)
       (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote reg)))
         (sck-tmd-tiling-exp-action x (quote modu-reg/reg) (vector nil (cddr x) (cdddr x))))))
    ((convsx)
     (case (cadr x)
       ((i16)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convsx-i8->i16/reg) (vector nil (cddr x)))))
       ((i32)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convsx-i8->i32/reg) (vector nil (cddr x)))
          (sck-tmd-tiling-exp-action x (quote convsx-i16->i32/reg) (vector nil (cddr x)))))))
    ((convzx)
     (case (cadr x)
       ((i16)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convzx-i8->i16/reg) (vector nil (cddr x)))))
       ((i32)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convzx-i8->i32/reg) (vector nil (cddr x)))
          (sck-tmd-tiling-exp-action x (quote convzx-i16->i32/reg) (vector nil (cddr x)))))))
    ((set)
     (case (cadr x)
       ((i32)
        (when (and (sck-tmd-exp-tile (caddr x) (quote mem)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote store-i32/stmt) (vector (cddr x) (cdddr x))))
        (case (car (cadddr x))
          ((add)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc1)))
               (sck-tmd-tiling-exp-action x (quote addl/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((sub)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc1)))
               (sck-tmd-tiling-exp-action x (quote subl/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((band)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc1)))
               (sck-tmd-tiling-exp-action x (quote andl/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((bor)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc1)))
               (sck-tmd-tiling-exp-action x (quote orl/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((bxor)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc1)))
               (sck-tmd-tiling-exp-action x (quote xorl/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((neg)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote negl/stmt) (vector (cddr x) (cddr (cadddr x)))))))
          ((bnot)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote notl/stmt) (vector (cddr x) (cddr (cadddr x)))))))
          ((lshs)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote con)))
               (sck-tmd-tiling-exp-action x (quote sall-con/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote sall-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((lshu)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote con)))
               (sck-tmd-tiling-exp-action x (quote shll-con/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote shll-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((rshs)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote con)))
               (sck-tmd-tiling-exp-action x (quote sarl-con/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote sarl-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((rshu)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote con)))
               (sck-tmd-tiling-exp-action x (quote shrl-con/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote shrl-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((mul)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote mrc3)))
               (sck-tmd-tiling-exp-action x (quote mul-mrc3/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((divs)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote divs-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((divu)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote divu-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((mods)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote mods-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((modu)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote modu-reg/stmt) (vector (cddr x) (cddr (cadddr x)) (cdddr (cadddr x)))))))
          ((convsx)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote convsx-i8->i32/stmt) (vector (cddr x) (cddr (cadddr x))))
               (sck-tmd-tiling-exp-action x (quote convsx-i16->i32/stmt) (vector (cddr x) (cddr (cadddr x)))))))
          ((convzx)
           (when (eq (cadr (cadddr x)) 'i32)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote convzx-i8->i32/stmt) (vector (cddr x) (cddr (cadddr x))))
               (sck-tmd-tiling-exp-action x (quote convzx-i16->i32/stmt) (vector (cddr x) (cddr (cadddr x))))))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote move-i32/stmt) (vector (cddr x) (cdddr x))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote addr)))
          (sck-tmd-tiling-exp-action x (quote leal/stmt) (vector (cddr x) (cdddr x))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mem)))
          (sck-tmd-tiling-exp-action x (quote load-i32/stmt) (vector (cddr x) (cdddr x)))))
       ((i16)
        (when (and (sck-tmd-exp-tile (caddr x) (quote mem)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote store-i16/stmt) (vector (cddr x) (cdddr x))))
        (case (car (cadddr x))
          ((convsx)
           (when (eq (cadr (cadddr x)) 'i16)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote convsx-i8->i16/stmt) (vector (cddr x) (cddr (cadddr x)))))))
          ((convzx)
           (when (eq (cadr (cadddr x)) 'i16)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote convzx-i8->i16/stmt) (vector (cddr x) (cddr (cadddr x)))))))
          ((convit)
           (when (eq (cadr (cadddr x)) 'i16)
             (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
               (sck-tmd-tiling-exp-action x (quote convit-i32->i16/stmt) (vector (cddr x) (cddr (cadddr x))))))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote move-i16/stmt) (vector (cddr x) (cdddr x))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mem)))
          (sck-tmd-tiling-exp-action x (quote load-i16/stmt) (vector (cddr x) (cdddr x)))))
       ((i8)
        (when (and (sck-tmd-exp-tile (caddr x) (quote mem)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote store-i8/stmt) (vector (cddr x) (cdddr x))))
        (when (eq (car (cadddr x)) 'convit)
          (when (eq (cadr (cadddr x)) 'i8)
            (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (caddr (cadddr x)) (quote reg)))
              (sck-tmd-tiling-exp-action x (quote convit-i32->i8/stmt) (vector (cddr x) (cddr (cadddr x))))
              (sck-tmd-tiling-exp-action x (quote convit-i16->i8/stmt) (vector (cddr x) (cddr (cadddr x)))))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote rc)))
          (sck-tmd-tiling-exp-action x (quote move-i8/stmt) (vector (cddr x) (cdddr x))))
        (when (and (sck-tmd-exp-tile (caddr x) (quote reg)) (sck-tmd-exp-tile (cadddr x) (quote mem)))
          (sck-tmd-tiling-exp-action x (quote load-i8/stmt) (vector (cddr x) (cdddr x)))))))
    ((convit)
     (case (cadr x)
       ((i16)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convit-i32->i16/reg) (vector nil (cddr x)))))
       ((i8)
        (when (sck-tmd-exp-tile (caddr x) (quote reg))
          (sck-tmd-tiling-exp-action x (quote convit-i32->i8/reg) (vector nil (cddr x)))
          (sck-tmd-tiling-exp-action x (quote convit-i16->i8/reg) (vector nil (cddr x)))))))
    ((jump)
     (when (sck-tmd-exp-tile (cadr x) (quote lab))
       (sck-tmd-tiling-exp-action x (quote jump/stmt) (vector (cdr x)))))
    ((jumpc)
     (case (car (cadr x))
       ((tsteq)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-eq-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstne)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-ne-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstlts)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-lts-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstles)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-les-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstgts)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-gts-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstges)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-ges-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstltu)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-ltu-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstleu)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-leu-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstgtu)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-gtu-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))
       ((tstgeu)
        (when (eq (cadr (cadr x)) 'i32)
          (when (and (sck-tmd-exp-tile (caddr (cadr x)) (quote reg)) (sck-tmd-exp-tile (cadddr (cadr x)) (quote mrc1)) (sck-tmd-exp-tile (caddr x) (quote lab)) (sck-tmd-exp-tile (cadddr x) (quote lab)))
            (sck-tmd-tiling-exp-action x (quote jumpc-geu-mrc1-i32/stmt) (vector (cddr (cadr x)) (cdddr (cadr x)) (cddr x) (cdddr x))))))))
    ((call)
     (when (sck-tmd-exp-tile (cadr x) (quote callarg))
       (sck-tmd-tiling-exp-action x (quote call/stmt) (vector (cdr x)))))))

