;;
;; graphviz $BI=<((B
;;
(defun sck-yayacc-graphviz-display (&optional non-content)
  (interactive)
  (graphviz-graph-display
   (sgraph-to-graphviz-graph 
    (sck-yayacc-sgraph non-content))))

;;
;; sck*yayacc-lra $B$+$i(B sgraph $B$r:n@.(B
;;
(defun sck-yayacc-sgraph (&optional non-content)
  (let (sgraph)
    ;; to (NodeID Content ((Successor..) ..))
    (dolist (x sck*yayacc-lra)
      (push (list 
	     (intern (format "State%s" (sck-yayacc-lra-state-index x)))
	     ;; Content
	     (unless non-content
	       (concat 
		(mapconcat #'(lambda (lr0)
			       (format "%s -> %s. %s"
				       (car lr0)
				       (if (cadr lr0)
					   (concat
					    (mapconcat #'(lambda (x)
							   (format "%S" x))
						       (cadr lr0)
						       " ")
					    " ")
					 "")
				       (mapconcat #'(lambda (x)
						      (format "%S" x))
						  (caddr lr0)
						  " ")))
			   (sck-yayacc-lra-state-lr0s x)
			   "\a")
		(when (sck-yayacc-lra-state-reduces x)
		  (concat 
		   "\a[Recuce]\a"
		   (mapconcat #'(lambda (reduce)
				  (format "%s ->%s:\a  %s"
					  (caar reduce)
					  (mapconcat #'(lambda (x)
							 (format "%S" x))
						     (cdar reduce)
						     " ")
					  (mapconcat #'(lambda (x)
							 (format "%S" x))
						     (cadr reduce)
						     " ")))
			      (sck-yayacc-lra-state-reduces x)
			      "\a")))
		"\a"))
	     ;; Edges
	     (let (edge)
	       (dolist (y (sck-yayacc-lra-state-succ x))
		 (push 
		  (list 
		   (intern (format "State%s" (cadr y)))
		   (format "%S" (car y)))
		  edge))
	       edge))
	    sgraph))
    (list (list 'node-list sgraph))))
